tests: Enhance retry test to cover failed reopen
[nbdkit/ericb.git] / tests / test-ssh.sh
blobe3506162d730eb2242950ab39dff692324b70b3b
1 #!/usr/bin/env bash
2 # nbdkit
3 # Copyright (C) 2018-2019 Red Hat Inc.
5 # Redistribution and use in source and binary forms, with or without
6 # modification, are permitted provided that the following conditions are
7 # met:
9 # * Redistributions of source code must retain the above copyright
10 # notice, this list of conditions and the following disclaimer.
12 # * Redistributions in binary form must reproduce the above copyright
13 # notice, this list of conditions and the following disclaimer in the
14 # documentation and/or other materials provided with the distribution.
16 # * Neither the name of Red Hat nor the names of its contributors may be
17 # used to endorse or promote products derived from this software without
18 # specific prior written permission.
20 # THIS SOFTWARE IS PROVIDED BY RED HAT AND CONTRIBUTORS ''AS IS'' AND
21 # ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
22 # THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
23 # PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL RED HAT OR
24 # CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
25 # SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
26 # LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
27 # USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
28 # ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
29 # OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
30 # OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
31 # SUCH DAMAGE.
33 source ./functions.sh
34 set -e
35 set -x
37 requires sshd -t -f ssh/sshd_config
38 requires qemu-img --version
40 # Check that ssh to localhost will work without any passwords or phrases.
41 requires ssh -V
42 if ! ssh -o PreferredAuthentications=none,publickey -o StrictHostKeyChecking=no localhost echo </dev/null
43 then
44 echo "$0: passwordless/phraseless authentication to localhost not possible"
45 exit 77
48 files="ssh.img"
49 rm -f $files
50 cleanup_fn rm -f $files
52 `which sshd` -f ssh/sshd_config -D -e &
53 sshd_pid=$!
54 cleanup_fn kill $sshd_pid
56 # Get the sshd port number which was randomly assigned.
57 port="$(grep ^Port ssh/sshd_config | awk '{print $2}')"
59 # Run nbdkit with the ssh plugin to copy a file.
60 nbdkit -v -D ssh.log=2 -U - \
61 ssh host=localhost $PWD/disk \
62 --run 'qemu-img convert $nbd ssh.img'
64 # The output should be identical.
65 cmp disk ssh.img